'use strict';

var _rollupPluginBabelHelpers = require('./internal/_rollupPluginBabelHelpers.js');

/**
 * @ en
 * bbo.formatDuration(1001); // '1 second, 1 millisecond'
 * bbo.formatDuration(34325055574); // '397 days, 6 hours, 44 minutes, 15 seconds, 574 milliseconds'
 */
var formatDuration = ms => {
  // eslint-disable-next-line no-param-reassign
  if (ms < 0) ms = -ms;
  var time = {
    day: Math.floor(ms / 86400000),
    hour: Math.floor(ms / 3600000) % 24,
    minute: Math.floor(ms / 60000) % 60,
    second: Math.floor(ms / 1000) % 60,
    millisecond: Math.floor(ms) % 1000
  };
  return Object.entries(time).filter(val => val[1] !== 0).map((_ref) => {
    var _ref2 = _rollupPluginBabelHelpers._slicedToArray(_ref, 2),
        key = _ref2[0],
        val = _ref2[1];

    return `${val} ${key}${val !== 1 ? 's' : ''}`;
  }).join(', ');
};

module.exports = formatDuration;
