'use strict';

var DEFAULT = {
  enabledType: false
};
function toDataUrl(url) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DEFAULT,
      enabledType = _ref.enabledType;

  return new Promise((resolve, reject) => {
    try {
      var request = new XMLHttpRequest();

      request.onload = () => {
        var reader = new FileReader();

        reader.onloadend = () => {
          if (enabledType) {
            var image = new Image();
            image.crossOrigin = 'Anonymous';
            image.src = reader.result;

            image.onload = () => {
              resolve(image);
            };
          } else {
            resolve(reader.result);
          }
        };

        reader.readAsDataURL(request.response);
      };

      request.open('GET', url, true);
      request.responseType = 'blob';
      request.send();
    } catch (error) {
      reject(error);
    }
  });
}

module.exports = toDataUrl;
